var _this, dataObj=[], _Tok = null;
new Vue({
	el: '#app',
	data: function() {
		return {
			tableData: [],
			nowForm:{
				postName:"",
				postCode:"",
				postSort:0,
				status:"0",
				remark:""
			},
			dialogVisible:false,
			inpKey:""
		}
	},
	created() {
		_this = this;
		_Tok = getCookie("Admin-Token") != "null" && getCookie("Admin-Token") != null ? getCookie("Admin-Token") : "";
		_this.getList();
	},
	methods: {
		getList() {
			let data1 = {
				pageNum:1,
				pageSize:100
			};
			let _opts = {
				url: baseUrl + "/system/post/list",
				type:"GET"
			};
			let _he = {
				"Authorization":"Bearer "+_Tok
			};
			getAxios(_opts, data1,_he)
			.then(function(res) {
				if (res.code == 200) {
					_this.tableData = res.rows;
					dataObj = res.rows;
				}else{
					_this.$message.error(res.msg);
				}
			})
		},
		Search(_key){
			let newArr = [],_ovj = dataObj;
			if(_key == ""){
				newArr = dataObj;
			}else{
				for(var i=0;i<_ovj.length;i++){
					if( JSON.stringify(_ovj[i]).indexOf(_key) != -1){
						newArr.push(_ovj[i])
					}
				}
			}
			_this.tableData = newArr;
		},
		newAdd(){
			_this.nowForm = {
				postName:"",
				postCode:"",
				postSort:0,
				status:"0",
				remark:""
			};
			_this.dialogVisible = true;
		},
		Edit(_row){
			let data1 = {};
			let _opts = {
				url: baseUrl + "/system/post/" + _row.postId,
				type:"GET"
			};
			let _he = {
				"Authorization":"Bearer "+_Tok
			};
			getAxios(_opts, data1,_he)
			.then(function(res) {
				if (res.code == 200) {
					_this.nowForm = res.data;
					_this.dialogVisible = true;
				}
			})
		},
		Delete(_row){
			_this.$confirm('是否确认删除编号为"'+_row.postId+'"的数据项?', '温馨提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then(() => {
				let data1 = {};
				let _opts = {
					url: baseUrl + "/system/post/"+_row.postId,
					type:"DELETE"
				};
				let _he = {
					"Authorization":"Bearer "+_Tok
				};
				getAxios(_opts, data1,_he)
				.then(function(res) {
					if(res.code == 200){
						_this.$message({
							type: 'success',
							message: '删除成功!'
						});
						_this.getList();
					}else{
						_this.$message.error(res.msg);
					}
				})
			}).catch(() => {
						
			});
		},
		conFirm(){
			if(_this.nowForm.postName == ""){
				_this.$message({
					type: 'warning',
					message: "请输入岗位名称"
				});
				return;
			}
			if(_this.nowForm.postCode == ""){
				_this.$message({
					type: 'warning',
					message: "请输入岗位编码"
				});
				return;
			}
			let data1 = JSON.stringify(_this.nowForm);
			let _opts = {
				url:baseUrl + "/system/post",
				type: _this.nowForm.postId == undefined?"POST":"PUT"
			};
			let _he = {
				"Authorization":"Bearer "+_Tok,
				"Content-Type": 'application/json; charset=UTF-8'
			};
			postAxios(_opts,data1,_he)
			.then(function(res){
				if(res.code == 200){
					_this.$message({
						type: 'success',
						message: '操作成功!'
					});
					_this.getList();
					_this.dialogVisible = false;
				}else{
					_this.$message.error(res.msg);
				}
			})
		}

	}
})