function getDTime(_key){
	let date = _key;
	const yyyy = date.getFullYear();
	const MM = date.getMonth() + 1 > 9 ? date.getMonth() + 1 : '0' + (date.getMonth() + 1);
	const dd = date.getDate() > 9 ? date.getDate() : '0' + date.getDate();
	const HH = date.getHours() > 9 ? date.getHours() : '0' + date.getHours();
	const mm = date.getMinutes() > 9 ? date.getMinutes() : '0' + date.getMinutes();
	const ss = date.getSeconds() > 9 ? date.getSeconds() : '0' + date.getSeconds();
	return [yyyy + '-' + MM + '-' + dd, " " + HH + ':' + mm + ':' + ss];
}
function getTree(data,parentId){
	var tree = [];
	var temp;
	for (var i = 0; i < data.length; i++) {
		if (data[i].pid == parentId) {
			var obj = data[i];
			obj["show"] = (data[i].pid == 0?true:false);
			obj["icon"] = (data[i].type == 0?'':(data[i].fence_type == 0?'icon-yuanxing':'icon-polygon'));
			temp = getTree(data, data[i].id);
			if (temp.length > 0) {
				obj.children = [...temp];
			}
			tree.push(obj);
		}
	}
	return tree;
}
function ShowLoading(_msg, _type) {
	var boarddiv = "<div class='mask_'><div>" + _msg + "</div></div>";
	$(document.body).append(boarddiv);
	if (_type == 1) {
		setTimeout(() => {
			$(".mask_").remove();
		}, 2000);
	}
}
//菜单列表html
var menus = '';
function GetData(arry, id) {
	var childArry = GetParentArry(id, arry);
	if (childArry.length > 0) {
		menus += '<ul>';
		for (var i in childArry) {
			if(childArry[i].type == 0){
				menus += `<li><div @click="changeShow(${childArry[i].id})" class="hasChild">
						<i class="iconfont icon-jia-xianxingfangkuang"></i>
						<span class="text-lg">${childArry[i].name}</span></div>`;
			}else{
				menus += `<li @click="showArea(${childArry[i].id})">
						<i class="iconfont ${(childArry[i].shape ==  0?'icon-yuanxing':'icon-polygon')}"></i>
						<span class="text-sm">${childArry[i].name}</span>`;
			}
			GetData(arry, childArry[i].id);
			menus += '</li>';
		}
		menus += '</ul>';
	}
	return menus;
}
function GetParentArry(id, arry) {
	var newArry = new Array();
	for (var i in arry) {
		if (arry[i].pid == id)
			newArry.push(arry[i]);
	}
	return newArry;
}
var baseUrl = "http://192.168.4.240:8091";
var vipUrl = "https://www.enstation.vip:9443";
var ys7Url = "https://open.ys7.com";
var helUrl = "https://caps.runde.pro/api";
// var staticUrl = "http://121.37.6.200/Zgcy";
var staticUrl = "http://192.168.4.242:32000/Zgcy";
// 封装请求
function getAxios(opts,_data,_head){
	$.Deferred(function(){});
	return new Promise(function(resolve, reject) {
		$.ajax({
			url: opts.url,
			type: "GET",
			traditional: true,
			dataType: "json",
			async: false, 
			headers: _head,
			data: _data,
			error: function(XMLHttpRequest, textStatus, errorThrown) {
			},
			success: function(res) {
				if(res.code == "10002"){
					alert("登录已过期，请重新登录....");
					ajaxErr();
				}else{
					resolve(res);
				}
			}
		})
	})
}
function postAxios(opts,_data,_head){
	$.Deferred(function(){});
	return new Promise(function(resolve, reject) {
		$.ajax({
			url: opts.url,
			type: "POST",
			traditional: true,
			dataType: "json",
			async: false, 
			headers: _head,
			data: _data,
			error: function(XMLHttpRequest, textStatus, errorThrown) {
			},
			success: function(res) {
				if(res.code == "10002"){
					alert("登录已过期，请重新登录....");
					ajaxErr();
				}else{
					resolve(res);
				}
			}
		})
	})
}
function ajaxErr(){
	delCookie("ylToken");
	localStorage.removeItem("nowShip");
	localStorage.removeItem("nowDevi");
	localStorage.removeItem("nowEnna");
	top.location.href = staticUrl + "/index.html";
}
//写cookies
function setCookie(name,value){
    var Days = 30;
    var exp = new Date();
    exp.setTime(exp.getTime() + 7*24*60*60*1000); //7天
    document.cookie = name + "="+ escape (value) + ";expires=" + exp.toGMTString()+";path=/";
}

//读取cookies
function getCookie(name){
    var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
    if(arr=document.cookie.match(reg)) return unescape(arr[2]);
    else return null;
}

//删除cookies
function delCookie(name){
    var exp = new Date();
    exp.setTime(exp.getTime() - 10000);
    var cval=getCookie(name);
    if(cval!=null) document.cookie= name + "="+cval+";expires="+exp.toGMTString()+"; path=/";
}
function clearCookie(){
    var keys=document.cookie.match(/[^ =;]+(?=\=)/g);
    if (keys) {
        for (var i = keys.length; i--;)
            document.cookie=keys[i]+'=0;expires=' + new Date( 0).toUTCString()
    }
} 
function checkLogin() {
	if (getCookie("ylToken") != "null" && getCookie("ylToken") != null) {
		clearStor();
	} else {
		top.location.href = staticUrl + "/index.html";
	}
}
function clearStor(){
    var href = origin = location.origin, pathname = location.pathname, search = location.search, hash = location.hash;
    var searchs = search.replace(/_t_=[^&\?]*[&\?]*/g, '').replace(/(^[&\?]*)|([&\?]*$)/g, '');
    if(localStorage.getItem('__clearcache__')) {
        localStorage.removeItem('__clearcache__');
        return history.replaceState({}, null, origin + pathname + (searchs ? '?' : '') + searchs + hash);
    }
    localStorage.setItem('__clearcache__', '1');
    location.replace(origin + pathname + '?' + searchs + (searchs ? '&' : '') + '_t_=' + new Date().valueOf() + hash);
}
var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
var pi = 3.14159265358979324;
var a = 6378245.0;
var ee = 0.00669342162296594323;

function transformLon(x, y) {
	var ret = 300.0 + x + 2.0 * y + 0.1 * x * x + 0.1 * x * y + 0.1 * Math.sqrt(Math.abs(x));
	ret += (20.0 * Math.sin(6.0 * x * pi) + 20.0 * Math.sin(2.0 * x * pi)) * 2.0 / 3.0;
	ret += (20.0 * Math.sin(x * pi) + 40.0 * Math.sin(x / 3.0 * pi)) * 2.0 / 3.0;
	ret += (150.0 * Math.sin(x / 12.0 * pi) + 300.0 * Math.sin(x / 30.0 * pi)) * 2.0 / 3.0;
	return ret;
};

function transformLat(x, y) {
	var ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(Math.abs(x));
	ret += (20.0 * Math.sin(6.0 * x * pi) + 20.0 * Math.sin(2.0 * x * pi)) * 2.0 / 3.0;
	ret += (20.0 * Math.sin(y * pi) + 40.0 * Math.sin(y / 3.0 * pi)) * 2.0 / 3.0;
	ret += (160.0 * Math.sin(y / 12.0 * pi) + 320 * Math.sin(y * pi / 30.0)) * 2.0 / 3.0;
	return ret;
}

function outOfChina(lat, lon) {
	if (lon < 72.004 || lon > 137.8347)
		return true;
	if (lat < 0.8293 || lat > 55.8271)
		return true;
	return false;
}
function wgsGcj(wgLat, wgLon) {
	var point = {};
	// if(wgLat>90&&wgLon<60){
	// 	let a = wgLat;
	// 	wgLat = wgLon;
	// 	wgLon = a;
	// }
	if (outOfChina(wgLat, wgLon)) {
		point.lat = wgLat;
		point.lon = wgLon;
		return point;
	}
	var dLat = transformLat(wgLon - 105.0, wgLat - 35.0);
	var dLon = transformLon(wgLon - 105.0, wgLat - 35.0);
	var radLat = wgLat / 180.0 * pi;
	var magic = Math.sin(radLat);
	magic = 1 - ee * magic * magic;
	var sqrtMagic = Math.sqrt(magic);
	dLat = (dLat * 180.0) / ((a * (1 - ee)) / (magic * sqrtMagic) * pi);
	dLon = (dLon * 180.0) / (a / sqrtMagic * Math.cos(radLat) * pi);
	var lat = wgLat + dLat;
	var lon = wgLon + dLon;
	point.lat = lat.toFixed(6);
	point.lon = lon.toFixed(6);
	return point;
};